%global githash d24301d1
%global gitdate 20211202

Name:           xnnpack
Version:        0
Release:        %{gitdate}.git%{githash}%{?dist}
Summary:        Highly optimized library of floating-point neural network
License:        BSD
URL:            https://github.com/google/xnnpack

Source0:        %{name}.tar.xz
Patch0:         %{name}-cmake.patch
Patch1:         xnnpack-gcc11.patch

ExclusiveArch:  x86_64 aarch64

BuildRequires:  cmake gcc-c++ git fp16-devel psimd-devel fxdiv-devel cpuinfo-devel pthreadpool-devel

%global __cmake_in_source_build 1

%description
XNNPACK is a highly optimized library of floating-point
neural network inference operators for ARM, WebAssembly,
and x86 (SSE2 level) platforms.

%package        devel
Summary:        Development files
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the development files.



%prep
%setup -q -n %{name}
# % patch1 -p0 -b .orig


%build

# externals
sed -i '/PRIVATE fp16/d' CMakeLists.txt
sed -i '/PRIVATE psimd/d' CMakeLists.txt
sed -i '/PRIVATE fxdiv/d' CMakeLists.txt
sed -i '/NOT TARGET clog/,/^ENDIF/d' CMakeLists.txt
sed -i '/NOT TARGET cpuinfo/,/^ENDIF/d' CMakeLists.txt
sed -i '/NOT TARGET pthreadpool/,/^ENDIF/d' CMakeLists.txt
sed -i '/NOT TARGET fxdiv/,/^ENDIF/d' CMakeLists.txt
sed -i '/NOT TARGET psimd/,/^ENDIF/d' CMakeLists.txt
sed -i '/NOT TARGET fp16/,/^ENDIF/d' CMakeLists.txt
sed -i -e 's|riscv|ppc64le\|riscv|g' CMakeLists.txt
sed -i -e 's|PROPERTIES PUBLIC_HEADER include/xnnpack.h|PROPERTIES PUBLIC_HEADER include/xnnpack.h SOVERSION 1 VERSION 1.0|g' CMakeLists.txt
# fix recent typo
sed -i 's|indirection src/indirection.c|indirection src/indirection.c)|' CMakeLists.txt
sed -i 's|packing.c))|packing.c)|' CMakeLists.txt

mkdir build
pushd build
%ifarch aarch64
export CFLAGS="%{optflags} -Wno-missing-braces -flax-vector-conversions"
%else
export CFLAGS="%{optflags} -Wno-missing-braces"
%endif
%cmake .. -Wno-dev \
       -DCMAKE_SKIP_RPATH=ON \
       -DCMAKE_VERBOSE_MAKEFILE=OFF \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DXNNPACK_BUILD_TESTS=OFF \
       -DXNNPACK_BUILD_BENCHMARKS=OFF \
       -DXNNPACK_USE_SYSTEM_LIBS=ON \
       -DCLOG_SOURCE_DIR="%{_includedir}" \
       -DFP16_SOURCE_DIR="%{_includedir}" \
       -DPSIMD_SOURCE_DIR="%{_includedir}" \
       -DFXDIV_SOURCE_DIR="%{_includedir}" \
       -DCPUINFO_SOURCE_DIR="%{_includedir}" \
       -DPTHREADPOOL_SOURCE_DIR="%{_includedir}"

make %{?_smp_mflags}

popd


%install

rm -rf %{buildroot}

pushd build
make install DESTDIR=%{buildroot}
popd



%files
%license LICENSE
%doc README.md
%{_libdir}/lib*.so.*

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/lib*.so


%changelog
* Tue Jul 11 2017 Cristian Balint <cristian.balint@gmail.com> - 0.1
- initial build
